<?php

//klasa_webmail-wersja1.php 

class Webmail {
    var $serwer = '';
    var $protokol = 'imap';
    var $obslugiwane_protokoly = array('imap', 'pop3', 'nntp');
    var $port = 143;
    var $id_uzytkownika = '';
    var $haslo_uzytkownika = '';
    var $strumien = 0;
    var $skrzynka = '';
    var $automatyczne_oczyszczanie = true;
        
    var $BLAD_SEPARATORA_ARGUMENTOW = " ";
    var $KOMUNIKAT_O_BLEDZIE = '';
        
    var $BLAD_POLACZENIE_NIEUDANE = 'Poczenie nieudane!';
    var $BLAD_NIEOBSLUGIWANY_PROTOKOL = 'Wybrany protok nie jest obsugiwany!';
    var $BLAD_ZAMKNIECIE_NIEUDANE = 'Bd zamknicia strumienia!';
    var $BLAD_FOLDER_NIEDOSTEPNY = 'Skrzynka niedostepna!';
    var $BLAD_NIEPRZESLONIETA_METODA_START = "Naley przesoni metod start()!";

    function inicjacja($serwer, $protokol='imap', $port=143, $id_uzytkownika='', $haslo_uzytkownika='') {
        $this->serwer = $serwer;
        $this->protokol = $protokol;
        $this->port = $port;
        $this->id_uzytkownika = $id_uzytkownika;
        $this->haslo_uzytkownika = $haslo_uzytkownika;
        $this->skrzynka = $GLOBALS["skrzynka"];
                
        if(!in_array($this->protokol, $this->obslugiwane_protokoly)) {
            $this->utworz_komunikat_o_bledzie($this->BLAD_NIEOBSLUGIWANY_PROTOKOL, $this->protokol);
            return false;
        }
                
        if($this->protokol == 'nntp' && empty($this->skrzynka)) 
            $tryb = OP_HALFOPEN;
        else $tryb = false;
            $this->strumien = @imap_open("\{$this->serwer/$this->protokol:$this->port}$this->skrzynka", $this->id_uzytkownika, $this->haslo_uzytkownika, $tryb);
                
        if(!$this->strumien) {
            $this->utworz_komunikat_o_bledzie($this->BLAD_POLACZENIE_NIEUDANE, imap_last_error());
            return false;
        }
        return true;
    }

    function start() {
        $this->utworz_komunikat_o_bledzie($this->BLAD_NIEPRZESLONIETA_METODA_START);
        return false;
    }

    function koniec() {
        if($this->automatyczne_oczyszczanie) $wynik = @imap_close($this->strumien, CL_EXPUNGE);
        else $wynik = @imap_close($this->strumien);
                
        if(!$wynik) {
            $this->utworz_komunikat_o_bledzie($this->BLAD_ZAMKNIECIE_NIEUDANE, imap_last_error());
            return false;
        }
        return true;
    }

    function utworz_komunikat_o_bledzie($komunikat, $argument_komunikatu='') {
        $this->KOMUNIKAT_O_BLEDZIE = $komunikat . $this->BLAD_SEPARATORA_ARGUMENTOW . $argument_komunikatu;
    }
        
    function komunikat_o_bledzie() {
        return $this->KOMUNIKAT_O_BLEDZIE;
    }
}
?>
